Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Namespace Members | Class Members | File Members | Related Pages

# ObstaclesSymbols Class Reference

The Xabsl2 symbols that are defined in "obstacles-symbols.xml". More...

`#include <ObstaclesSymbols.h>`

Inheritance diagram for ObstaclesSymbols:

[legend]
Collaboration diagram for ObstaclesSymbols:

[legend]
List of all members.

## Public Types
enum | { sizeOfArray = 5 }
## Public Member Functions
| ObstaclesSymbols (const BehaviorControlInterfaces &interfaces)
void | registerSymbols (Xabsl2Engine &engine)
| registers the symbols at an engine
void | update ()
| updates the symbols
Input symbols
bool | getCollisionFrontLeft ()
bool | getCollisionFrontRight ()
bool | getCollisionHindLeft ()
bool | getCollisionHindRight ()
bool | getCollisionHead ()
bool | getCollisionAggregate ()
double | getOdometryDisturbance ()
double | getConsecutiveCollisionTimeFrontLeft ()
double | getConsecutiveCollisionTimeFrontRight ()
double | getConsecutiveCollisionTimeHindLeft ()
double | getConsecutiveCollisionTimeHindRight ()
double | getConsecutiveCollisionTimeHead ()
double | getConsecutiveCollisionTimeAggregate ()
double | getMinDistanceLeft ()
double | getMinDistanceRight ()
double | getMinDistanceMiddle ()
int | getCollisionSide ()
bool | getObstacleInFront ()
double | getNearestObstacleFrontLeft ()
double | getNearestObstacleFrontRight ()
## Public Attributes
double | lastValuesLeft [sizeOfArray]
int | lastValuesMiddle [sizeOfArray]
double | lastValuesRight [sizeOfArray]
bool | robotIsStuck
| Indicates if the robot is stuck (based on obstacles model).
bool | obstaclesAreClose
| Indicates that there are close obstacles.
bool | opponentsCloseToBall
| Indicates that there are opponents in the direction of the ball.

## Detailed Description

The Xabsl2 symbols that are defined in "obstacles-symbols.xml".

Author:
  Max Risler

Definition at line 21 of file ObstaclesSymbols.h.

## Member Enumeration Documentation

anonymous enum

  | Enumeration values:
  sizeOfArray |
Definition at line 31 of file ObstaclesSymbols.h.

## Constructor & Destructor Documentation

ObstaclesSymbols::ObstaclesSymbols | ( | const BehaviorControlInterfaces & | interfaces | ) |

| Definition at line 11 of file ObstaclesSymbols.cpp. References lastValuesLeft, lastValuesMiddle, lastValuesRight, and sizeOfArray.

## Member Function Documentation

void ObstaclesSymbols::registerSymbols | ( | Xabsl2Engine & | engine | ) |

| registers the symbols at an engine Definition at line 24 of file ObstaclesSymbols.cpp. References getCollisionAggregate(), getCollisionFrontLeft(), getCollisionFrontRight(), getCollisionHead(), getCollisionHindLeft(), getCollisionHindRight(), getCollisionSide(), getConsecutiveCollisionTimeAggregate(), getConsecutiveCollisionTimeFrontLeft(), getConsecutiveCollisionTimeFrontRight(), getConsecutiveCollisionTimeHead(), getConsecutiveCollisionTimeHindLeft(), getConsecutiveCollisionTimeHindRight(), getMinDistanceLeft(), getMinDistanceMiddle(), getMinDistanceRight(), getNearestObstacleFrontLeft(), getNearestObstacleFrontRight(), getObstacleInFront(), getOdometryDisturbance(), obstaclesAreClose, opponentsCloseToBall, Xabsl2Symbols::registerBooleanInputSymbol(), Xabsl2Symbols::registerDecimalInputSymbol(), Xabsl2Symbols::registerEnumeratedInputSymbol(), Xabsl2Symbols::registerEnumeratedInputSymbolEnumElement(), and robotIsStuck. Referenced by GT2005BehaviorControl::registerSymbolsAndBasicBehaviors().

Here is the call graph for this function:

void ObstaclesSymbols::update | ( |  | ) |

| updates the symbols Definition at line 101 of file ObstaclesSymbols.cpp. References Geometry::distanceTo(), fromDegrees(), ObstaclesModel::getMinimalDistanceInRange(), ObstaclesModel::getPercentageOfLowDistanceObstaclesInRange(), RobotPose::getPose(), obstaclesAreClose, opponentsCloseToBall, pi_2, BallState::positionField, robotIsStuck, and BallModel::seen. Referenced by GT2005BehaviorControl::execute().

Here is the call graph for this function:

bool ObstaclesSymbols::getCollisionFrontLeft | ( |  | ) |

| A function for the symbol "self.collision-front-left" Definition at line 124 of file ObstaclesSymbols.cpp. References RobotState::getCollisionFrontLeft(). Referenced by registerSymbols().

Here is the call graph for this function:

bool ObstaclesSymbols::getCollisionFrontRight | ( |  | ) |

| A function for the symbol "self.collision-front-right" Definition at line 129 of file ObstaclesSymbols.cpp. References RobotState::getCollisionFrontRight(). Referenced by registerSymbols().

Here is the call graph for this function:

bool ObstaclesSymbols::getCollisionHindLeft | ( |  | ) |

| A function for the symbol "self.collision-hind-left" Definition at line 134 of file ObstaclesSymbols.cpp. References RobotState::getCollisionHindLeft(). Referenced by registerSymbols().

Here is the call graph for this function:

bool ObstaclesSymbols::getCollisionHindRight | ( |  | ) |

| A function for the symbol "self.collision-hind-right" Definition at line 139 of file ObstaclesSymbols.cpp. References RobotState::getCollisionHindRight(). Referenced by registerSymbols().

Here is the call graph for this function:

bool ObstaclesSymbols::getCollisionHead | ( |  | ) |

| A function for the symbol "self.collision-head" Definition at line 144 of file ObstaclesSymbols.cpp. References RobotState::getCollisionHead(). Referenced by registerSymbols().

Here is the call graph for this function:

bool ObstaclesSymbols::getCollisionAggregate | ( |  | ) |

| A function for the symbol "self.collision-aggregate" Definition at line 149 of file ObstaclesSymbols.cpp. References RobotState::getCollisionAggregate(). Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getOdometryDisturbance | ( |  | ) |

| A function for the symbol "self.odometry-disturbance" Definition at line 154 of file ObstaclesSymbols.cpp. References RobotState::getOdometryDisturbance(). Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getConsecutiveCollisionTimeFrontLeft | ( |  | ) |

| A function for the symbol "self.consecutive-collision-time-front-left" Definition at line 159 of file ObstaclesSymbols.cpp. References RobotState::getConsecutiveCollisionTimeFrontLeft(). Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getConsecutiveCollisionTimeFrontRight | ( |  | ) |

| A function for the symbol "self.consecutive-collision-time-front-right" Definition at line 164 of file ObstaclesSymbols.cpp. References RobotState::getConsecutiveCollisionTimeFrontRight(). Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getConsecutiveCollisionTimeHindLeft | ( |  | ) |

| A function for the symbol "self.consecutive-collision-time-hind-left" Definition at line 169 of file ObstaclesSymbols.cpp. References RobotState::getConsecutiveCollisionTimeHindLeft(). Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getConsecutiveCollisionTimeHindRight | ( |  | ) |

| A function for the symbol "self.consecutive-collision-time-hind-right" Definition at line 174 of file ObstaclesSymbols.cpp. References RobotState::getConsecutiveCollisionTimeHindRight(). Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getConsecutiveCollisionTimeHead | ( |  | ) |

| A function for the symbol "self.consecutive-collision-time-head" Definition at line 179 of file ObstaclesSymbols.cpp. References RobotState::getConsecutiveCollisionTimeHead(). Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getConsecutiveCollisionTimeAggregate | ( |  | ) |

| A function for the symbol "self.consecutive-collision-time-aggregate" Definition at line 184 of file ObstaclesSymbols.cpp. References RobotState::getConsecutiveCollisionTimeAggregate(). Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getMinDistanceLeft | ( |  | ) |

| A function for the symbol "self.collision-front-left" Definition at line 191 of file ObstaclesSymbols.cpp. References ObstaclesModel::getMinimalDistanceInRange(), lastValuesLeft, pi, and sizeOfArray. Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getMinDistanceRight | ( |  | ) |

| A function for the symbol "self.collision-front-left" Definition at line 215 of file ObstaclesSymbols.cpp. References ObstaclesModel::getMinimalDistanceInRange(), lastValuesRight, pi, and sizeOfArray. Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getMinDistanceMiddle | ( |  | ) |

| A function for the symbol "self.collision-front-left" Definition at line 239 of file ObstaclesSymbols.cpp. References ObstaclesModel::corridorInFront. Referenced by registerSymbols().

int ObstaclesSymbols::getCollisionSide | ( |  | ) |

| A function for the symbol "self.collision-side" Definition at line 244 of file ObstaclesSymbols.cpp. References RobotState::getCollisionSide(). Referenced by registerSymbols().

Here is the call graph for this function:

bool ObstaclesSymbols::getObstacleInFront | ( |  | ) |

| A function for the symbol "self.collision-front-left" Definition at line 249 of file ObstaclesSymbols.cpp. References ObstaclesModel::getDistanceInDirection(), ObstaclesModel::getPercentageOfLowDistanceObstaclesInRange(), and pi. Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getNearestObstacleFrontLeft | ( |  | ) |

| A function for the symbol "self.collision-front-left" Definition at line 272 of file ObstaclesSymbols.cpp. References ObstaclesModel::getDistanceInDirection(), and pi. Referenced by registerSymbols().

Here is the call graph for this function:

double ObstaclesSymbols::getNearestObstacleFrontRight | ( |  | ) |

| A function for the symbol "self.collision-front-left" Definition at line 263 of file ObstaclesSymbols.cpp. References ObstaclesModel::getDistanceInDirection(), and pi. Referenced by registerSymbols().

Here is the call graph for this function:

## Member Data Documentation

double ObstaclesSymbols::lastValuesLeft[sizeOfArray]

| Definition at line 33 of file ObstaclesSymbols.h. Referenced by getMinDistanceLeft(), and ObstaclesSymbols().

int ObstaclesSymbols::lastValuesMiddle[sizeOfArray]

| Definition at line 34 of file ObstaclesSymbols.h. Referenced by ObstaclesSymbols().

double ObstaclesSymbols::lastValuesRight[sizeOfArray]

| Definition at line 35 of file ObstaclesSymbols.h. Referenced by getMinDistanceRight(), and ObstaclesSymbols().

bool ObstaclesSymbols::robotIsStuck

| Indicates if the robot is stuck (based on obstacles model). Definition at line 71 of file ObstaclesSymbols.h. Referenced by registerSymbols(), and update().

bool ObstaclesSymbols::obstaclesAreClose

| Indicates that there are close obstacles. Definition at line 74 of file ObstaclesSymbols.h. Referenced by registerSymbols(), and update().

bool ObstaclesSymbols::opponentsCloseToBall

| Indicates that there are opponents in the direction of the ball. Definition at line 77 of file ObstaclesSymbols.h. Referenced by registerSymbols(), and update().

The documentation for this class was generated from the following files:

- Modules/BehaviorControl/CommonXabsl2Symbols/ObstaclesSymbols.h
- Modules/BehaviorControl/CommonXabsl2Symbols/ObstaclesSymbols.cpp